#!/bin/bash

# Don't dial again
if test -n "`ifconfig|grep ppp`" ; then
   echo "WARNING:you have already logged in,don't dial again!"
   exit 0
fi

# Must be root
if test "`/usr/bin/id -u`" != 0 ; then
   echo "$0: You must be root to run this script" >& 2
   exit 1
fi

echo "重邮openkeeper built版i386"
#DEBUG=1
cd $(dirname $0)
PPPOE_START=/usr/sbin/pppoe-start

CONFIG_PATH=./config
if [ ! -d $CONFIG_PATH ] ; then
	echo "首次使用，调用ok-config命令进行配置，若配置错误将无法登录"
	ok-config
fi

#请务必在下面填上自己的网卡、账号和密码
#网卡:
default_eth=`cat $CONFIG_PATH/eth`
ppp_eth=ppp0

#用户名:
username=`cat $CONFIG_PATH/user`
#密码:
password=`cat $CONFIG_PATH/pass`

count=0
maxcount=2  #拨号失败重试次数
echo $username > Netkeeper.dat
pppoe-stop > /dev/null 2>&1
echo "尝试使用用户名$username,网卡$default_eth拨号"
until test -n "`ifconfig | grep ppp`"
do
	if [ "$count" != 0 ]
		then echo "第$count次登录失败"
	fi
	realusername=`./dialnetkeeper`
	realusername=${realusername//\"/\\\"}
	cp pppoe.conf pppoe.conf-tmp
	cp pap-secrets pap-secrets-tmp
	echo "ETH=$default_eth" >> pppoe.conf-tmp
	echo "USER='\"$realusername\"'" >> pppoe.conf-tmp
	echo "\"$realusername\"	*	\"$password\"" >> pap-secrets-tmp
	cp pppoe.conf-tmp /etc/ppp/pppoe.conf
	cp pap-secrets-tmp /etc/ppp/pap-secrets
	$PPPOE_START
	if test -n "`ifconfig|grep ppp`" ; then
		break
	else
		count=`expr $count + 1`
		if [ "$count" -eq "$maxcount" ]
		then echo "达到最大失败次数，请检查账户时间，账户密码，网卡等配置，或者稍后再试;若配置错误，修改配置后，退出原终端后，在新终端中拨号（若在新终端中失败，请多试几次,或者使用ok-reflesh重置openkeeper，或者稍后再试）。"
		exit 0
		fi
		sleep 1
	fi
done
echo 登录成功

tmp_ip=`ifconfig $ppp_eth|awk "(/[0-9]?[0-9]?[0-9]\.[1-9]?[1-9]?[1-9]\.[0-9]?[0-9]?[0-9]\.[0-9]?[0-9]?[0-9]/) {print}"|cut -d: -f2`
tmp_ip=${tmp_ip%% *}
ppp_ip=$tmp_ip
# 添加外网路由
echo "外网IP:$ppp_ip"
route add default -e $ppp_eth

gateway_ip=`/sbin/route -n|grep 0.0.0.0.*172|cut -c17-28`
if test -n $gateway_ip ; then
	echo "正在为网卡$default_eth IP:$gateway_ip添加内网路由..."
	route del -net 172.0.0.0/8 > /dev/null 2>&1
	route del -net 202.202.0.0/16 > /dev/null 2>&1
	route add -net 172.0.0.0/8 gw $gateway_ip -e $default_eth > /dev/null 2>&1
	route add -net 202.202.0.0/16 gw $gateway_ip -e $default_eth > /dev/null 2>&1
fi
echo "拨号结束，若关闭本终端，不会断开网络连接，断开网络连接请使用ok-stop命令"
echo "处理完毕，若要使用其他账户登录，请用ok-config重新配置或用ok-refesh重置openkeeper"
exit 0
